clear; close all;
disp(' global A B');
global A B
disp(' % Als erstes werden zwei 5x5-Zufallsmatrizen A und B erzeugt.');
disp(' A = rand(5);');
A = rand(5);
disp(' B = rand(5);');
B = rand(5);
disp('');
disp(' % Dann wird das Funktion-File der Funktion geschrieben.');
disp('');
disp(' function y = charPoly(x)');
disp(' global A,B;');
disp(' y = det(A - x*B);');
disp('');
disp(' % Dann wird die Funktion und die x-Achse gezeichnet.');
disp(' lambda = linspace(-5,5,1000);');
lambda = linspace(-5,5,1000);
disp(' y = [];');
disp(' for n = 1:1000,');
disp('    y(n) = charPoly(lambda(n));');
disp(' end;');
y = [];
for n = 1:1000,
   y(n) = charPoly(lambda(n));
end;
disp(' plot(lambda,y,''b'');');
plot(lambda,y,'b');
disp(' hold on;');
hold on;
disp(' plot([-5 5],[0 0],''k'');');
plot([-5 5],[0 0],'k');
disp('Weiter mit Return');
pause
disp('');
disp(' % Mit der Funktion fzero erhlt man nur eine Nullstelle, die nchstliegende zum');
disp(' % angegebenen Wert, deshalb werden in einer Schleife die Vorzeichen zweier  ');
disp(' % benachbarter Funktionswerte verglichen. Ist das Produkt kleiner Null haben sie');
disp(' % unterschiedliche Vorzeichen und eine Nullstelle liegt zwischen den beiden Werten.');
disp(' k = 0;');
disp(' m = 1;');
disp(' null = [];');
disp(' while m < 999,');
disp(' 	m = m+1;');
disp(' 	if charPoly(lambda(m-1))*charPoly(lambda(m))<0,');
disp(' 		k = k+1;');
disp(' 		null(k) = lambda(m);');
disp(' 	end;');
disp(' end;');
disp(' null');
k = 0;
m = 1;
null = [];
while m < 999,
   m = m+1;
   if charPoly(lambda(m-1))*charPoly(lambda(m))<0,
      k = k+1;
      null(k) = lambda(m);
   end;
end;
null
disp(' % Diese Nullstellen sind etwas ungenauer als mit fzero. Um genauere Werte zu');
disp(' % bekommen knnte man die Aufteilung der Achse vergreren.');
disp('Weiter mit Return');
pause
disp('');
disp(' % Zum Schlu wird noch ein Minimum gesucht. Dazu kann die Funktion fmins ');
disp(' % verwendet werden.');
disp(' fmins(''charPoly'',-5)');
fmins('charPoly',-5)
disp(' % Meistens hat die Funktion kein lokales Minimum. Sie geht in den meisten Fllen');
disp(' % gegen -Unendlich.');
pause
exit
