clear; close all;
disp(' % Zunchst wird eine Zufalls-Matrix A erzeugt:');
disp(' A = rand(4)');
A = rand(4)
disp(' % Nun wird die Inverse mit Unterdeterminanten berechnet und dabei die Zeit');
disp(' % mit den Funktionen tic und toc gestoppt:');
disp(' tic');
disp(' Det = det(A);');
disp(' Adj = zeros(3);');
disp(' Adj(1,1) = det(A(2:4,2:4));');
disp(' Adj(1,2) = -det(A([1 3 4],2:4));');
disp(' Adj(1,3) = det(A([1 2 4],2:4));');
disp(' Adj(1,4) = -det(A(1:3,2:4));');
disp(' Adj(2,1) = -det(A(2:4,[1 3 4]));');
disp(' Adj(2,2) = det(A([1 3 4],[1 3 4]));');
disp(' Adj(2,3) = -det(A([1 2 4],[1 3 4]));');
disp(' Adj(2,4) = det(A(1:3,[1 3 4]));');
disp(' Adj(3,1) = det(A(2:4,[1 2 4]));');
disp(' Adj(3,2) = -det(A([1 3 4],[1 2 4]));');
disp(' Adj(3,3) = det(A([1 2 4],[1 2 4]));');
disp(' Adj(3,4) = -det(A(1:3,[1 2 4]));');
disp('Weiter mit Return');
pause
disp(' Adj(4,1) = -det(A(2:4,1:3));');
disp(' Adj(4,2) = det(A([1 3 4],1:3));');
disp(' Adj(4,3) = -det(A([1 2 4],1:3));');
disp(' Adj(4,4) = det(A(1:3,1:3));');
disp(' Inv = 1/Det*Adj');
disp(' toc');
tic
Det=det(A);
Adj = zeros(3);
Adj(1,1) = det(A(2:4,2:4));
Adj(1,2) = -det(A([1 3 4],2:4));
Adj(1,3) = det(A([1 2 4],2:4));
Adj(1,4) = -det(A(1:3,2:4));
Adj(2,1) = -det(A(2:4,[1 3 4]));
Adj(2,2) = det(A([1 3 4],[1 3 4]));
Adj(2,3) = -det(A([1 2 4],[1 3 4]));
Adj(2,4) = det(A(1:3,[1 3 4]));
Adj(3,1) = det(A(2:4,[1 2 4]));
Adj(3,2) = -det(A([1 3 4],[1 2 4]));
Adj(3,3) = det(A([1 2 4],[1 2 4]));
Adj(3,4) = -det(A(1:3,[1 2 4]));
Adj(4,1) = -det(A(2:4,1:3));
Adj(4,2) = det(A([1 3 4],1:3));
Adj(4,3) = -det(A([1 2 4],1:3));
Adj(4,4) = det(A(1:3,1:3));
Inv = 1/Det*Adj
toc
disp('Weiter mit Return');
pause
disp('');
disp(' % Nun wird die Inverse mit der Funktion inv berechnen und auch die Zeit');
disp(' % gestoppt.');
disp(' tic');
disp(' Inv = inv(A)');
disp(' toc');
tic
Inv = inv(A)
toc
disp('Weiter mit Return');
pause
disp('');
disp(' % Nun wird noch die Anzahl der Gleitpunktoperationen bei einer 30x30 Zufalls-');
disp(' % matrix berechnet:');
disp(' % Fr die Berechnung mit den Unterdeterminanten braucht man die flops fr die');
disp(' % Berechnung einer Determinante (die Unterdeterminanten haben die Gre 29x29):');
disp(' Dflops = 2/3*30^3 - 1/2*30^2 + 5/6*30 - 1');
Dflops = 2/3*30^3 - 1/2*30^2 + 5/6*30 - 1
disp(' Uflops = 2/3*29^3 - 1/2*29^2 + 5/6*29 - 1');
Uflops = 2/3*29^3 - 1/2*29^2 + 5/6*29 - 1
disp(' % Bei einer 30x30 Matrix werden 30^2 Unterdeterminanten gebraucht und die ');
disp(' % Determinante der Matrix selbst:');
disp(' flops = Dflops + 30^2*Uflops');
flops = Dflops + 30^2*Uflops
disp('Weiter mit Return');
pause
disp('');
disp(' % Nun die Gleitpunktoperationen fr die Funktion inv:');
disp(' Iflops = 8/3*30^3 - 1/2*30^2 - 1/6*30');
Iflops = 8/3*30^3 - 1/2*30^2 - 1/6*30
disp(' % Bei einer 30x30 Matrix wrden sich dann auch die Berechnungswege zeitlich');
disp(' % sehr unterscheiden.');
pause
exit
