clear; close all;
disp(' % Aus den Gleichungen erhlt man die Koeffizientenmatrix A und die rechte Seite b:');
disp(' A = [5 -1 -2; 1 -6 3; -2 1 4]');
A = [5 -1 -2; 1 -6 3; -2 1 4]
disp(' b = [2 -2 3]''');
b = [2 -2 3]'
disp(' % Zuerst das Gau-Jacobi-Verfahren:');
disp(' % Die Matrix A wird in eine Diagonalmatrix, eine obere und eine untere');
disp(' % Dreiecksmatrix ohne Diagonale zerlegt: A = D - (L+R)');
disp(' D = diag(diag(A));');
D = diag(diag(A));
disp(' L = -(tril(A)-D);');
L = -(tril(A)-D);
disp(' R = -(triu(A)-D);');
R = -(triu(A)-D);
disp(' % Durch Umformen von Ax=b kommt man zu: x = inv(D)*(L+R)*x + inv(D)*b');
disp(' % Als Startvektor wird der Nullvektor genommen.');
disp(' x = zeros(3,1);');
x = zeros(3,1);
disp('Weiter mit Return');
pause
disp('');
disp(' for k = 1:10');
disp(' 	k = k');
disp(' 	x = inv(D)*(L+R)*x + inv(D)*b');
disp('	disp(''Weiter mit Return'');');
disp(' 	pause');
disp(' end');
for k = 1:10
   k=k
   x = inv(D)*(L+R)*x + inv(D)*b
	disp('Weiter mit Return');
 	pause
end
disp(' % Man kann vermuten, dass die Lsung [1 1 1]'' lautet.');
disp('Weiter mit Return');
pause
disp('');
disp(' % Nun das Gau-Seidel-Verfahren:');
disp(' % Die Matrix A wird auch in eine Diagonalmatrix, eine obere und eine untere');
disp(' % Dreiecksmatrix ohne Diagonale zerlegt: A = D - L - R');
disp(' % Hier wird Ay=b anders umgeformt: y = inv(D-L)*R*y + inv(D-L)*b');
disp(' % Der Startvektor ist wieder der Nullvektor:');
disp(' y = zeros(3,1);');
y = zeros(3,1);
disp('');
disp(' for k = 1:10');
disp(' 	k = k');
disp(' 	y = inv(D-L)*R*y + inv(D-L)*b');
disp('	disp(''Weiter mit Return'');');
disp(' 	pause');
disp(' end');
for k = 1:10
   k=k
   y = inv(D-L)*R*y + inv(D-L)*b
   disp('Weiter mit Return');
 	pause
end
disp(' % Dieses Verfahren konvergiert schneller und besttigt die Vermutung, ');
disp(' % dass die Lsung [1 1 1]'' lautet.');
disp(' z = A\b');
z = A\b
disp(' % Die Ergebnisse zum Vergleichen:');
disp(' Loesungen = [x y z]');
Loesungen = [x y z]
pause
exit
